#include "ddos.h"
#include <string.h>

/* Find then length of a string where it might
 * not be zero-terminated;
 */
/*
int strnlen(char s[], int max) {
    int i;
    for (i = 0; i < max; i++) {
        if (*s++ == '\0') return i;
    }
    return max;
}
*/

int getsize(struct allocblock *b, int num, int last) {
    int sum = 0;
    int i;

    for (i = 0; i < num; i++) {
        sum += b[i].count * 256;
    }
    sum = sum - 256 + last;
    return sum;
}

/*
 * List the directory of a DragonDos formatted disk.
 * Does not calculate size of files with continuations correctly.
 */
void listdir(FILE *fp, struct diskinfo *h) {
    int i, sector, recnum;
    struct dentry tocrec;
    char unused[6];
    int eod, deleted, contentry, conted;
    char namebuffer[16];

    seektodir(fp, h);
    recnum = 0;
    for (sector = 0; sector < 18; sector++) {
        for (i = 0; i < 10; i++) {
            fread(&tocrec, sizeof tocrec, 1, fp);
            eod = (tocrec.flag & 8) != 0;
            deleted = (tocrec.flag & 128) != 0;
            contentry = tocrec.flag & 1;
            if (eod) {
                return;
            }
            conted = tocrec.flag & 32;
            if (!contentry && !deleted) {
                memset(namebuffer, 0, sizeof namebuffer);
                strncpy(namebuffer, tocrec.name, strnlen(tocrec.name, 8));
                strcat(namebuffer, ".");
                strncat(namebuffer, tocrec.ext, strnlen(tocrec.ext, 3));
                printf("%-14s%6d\n", namebuffer, getsize(tocrec.alloc, 4, tocrec.last));
            }
            recnum += 1;
        }
        fread(&unused, sizeof unused, 1, fp); // Skip unused bytes
    }
}

int main(int argc, char *argv[]) {
    FILE *fp;
    int i, sz;
    struct diskinfo h;

    if (argc < 2) {
        fprintf(stderr, "Usage: %s disk_image...\n", argv[0]);
        exit(1);
    }
    for (i = 1; i < argc; i++) {
        printf("%s\n", argv[i]);
        printf("======================\n");
        fp = fopen(argv[i], "r");
        vdkhead(fp, &h);
        listdir(fp, &h);
        printf("\n");
        fclose(fp);
    }
}

