/*
 * Convert a 6144 byte picture to PBM format
 */

#include <getopt.h>
#include <unistd.h>
#include "ddos.h"

void usage(char *prgname) {
    fprintf(stderr, "Usage: [-i] %s <bin file>\n", prgname);
    exit(EXIT_FAILURE);
}

int main(int argc, char *argv[]) {

    FILE *fp, *outfp;
    struct fileinfo header;
    int c, opt, invert;

    invert = 0;
    while ((opt = getopt(argc, argv, "i")) != -1) {
        switch(opt) {
        case 'p':
            invert = 1;
            break;
        default:
            usage(argv[0]);
        }
    }

    if (optind >= argc) {
        usage(argv[0]);
    }
    fp = fopen(argv[optind], "r");
    fread(&header, 9, 1, fp);
    if (header.startmark != 0x55 && header.endmark != 0xAA && header.filetype != 2) {
        fprintf(stderr, "This is not a binary Dragon Dos file\n");
        exit(2);
    }
    outfp = stdout;

    fprintf(outfp, "P4\n");
    fprintf(outfp, "256 192\n");
    while ((c = getc(fp)) != EOF) {
        if (invert) c ^= 0xFF;
        putc(c & 0xFF, outfp);
    }
}

