/*
 * Convert .DSK to .VDK
 */
#include "ddos.h"
#include <string.h>

static struct diskinfo *h;

char *createOutName(char *inFilename) {
    int nameLength;
    static char dsksuffix[5] = ".dsk";
    char *newFilename;

    if (inFilename == NULL) return NULL;

    nameLength = strlen(inFilename);

    if (nameLength == 0) return NULL;
    newFilename = malloc(nameLength + 4);

    strcpy(newFilename, inFilename);
    char *suffixPtr = &newFilename[nameLength - 4];
    if (!strcasecmp(suffixPtr, dsksuffix)) {
        strcpy(suffixPtr, ".vdk");
    } else {
        strcat(newFilename, ".vdk");
    }
    return newFilename;
}

int main(int argc, char *argv[]) {
    FILE *fpin;
    FILE *fpout;
    int c,i;
    char *outFilename;
    struct diskinfo hrec;

    if (argc < 2) {
        fprintf(stderr, "Usage: %s <disk>...\n", argv[0]);
        exit(1);
    }

    h = &hrec;
    for (i = 1; i < argc; i++) {
        fpin = fopen(argv[i], "r");

        vdkhead(fpin, h);
        rewind(fpin);
        outFilename = createOutName(argv[i]);

        if (outFilename != NULL) {

            fpout = fopen(outFilename, "w");
            h->diskname = outFilename;
            writehead(fpout, h);
            while((c = getc(fpin)) != EOF) {
                putc(c, fpout);
            }
            fclose(fpout);
        }
        fclose(fpin);
    }
}

