/*
 * Remove the VDK header.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *createOutName(char *inFilename) {
    int nameLength;
    static char vdksuffix[5] = ".vdk";
    char *newFilename;

    if (inFilename == NULL) return NULL;

    nameLength = strlen(inFilename);

    if (nameLength == 0) return NULL;
    newFilename = malloc(nameLength + 4);

    strcpy(newFilename, inFilename);
    char *suffixPtr = &newFilename[nameLength - 4];
    if (!strcasecmp(suffixPtr, vdksuffix)) {
        strcpy(suffixPtr, ".dsk");
    } else {
        strcat(newFilename, ".dsk");
    }
    return newFilename;
}

int main(int argc, char *argv[]) {
    FILE *fpin;
    FILE *fpout;
    char header[8];
    int headersize;
    int c,i;
    char *outFilename;


    for (i = 1; i < argc; i++) {
        fpin = fopen(argv[i], "r");

        /* Magic 'dk' */
        fread(header, 1, 2, fpin);
        if (header[0] != 'd' && header[1] != 'k') {
            fprintf(stderr, "Input file is not a VDK disk\n");
            return 0;
        }
        /* Header length */
        fread(header, 1, 2, fpin);
        headersize = header[0] + header[1] * 256;

        fseek(fpin, headersize, SEEK_SET);
        outFilename = createOutName(argv[i]);

        if (outFilename != NULL) {

            fpout = fopen(outFilename, "w");
            while((c = getc(fpin)) != EOF) {
                putc(c, fpout);
            }
            fclose(fpout);
        }
        fclose(fpin);
    }
}
